#include "InstallerTypes.r"

//	This little example shows how to copy the contents of a folder to the destination drive.  It uses
//	the 'infm' resource atom which has the total size of the source files and of course the appropriate
//	'infs' for the target and the source folders.

//	NOTE:  There are NO flags like there are for the 'infa', for updating and deletes.  In other words,
//			all of the files in the source folder will always be copied on the Install and NO files will
//			be deleted on the Remove.  If you need these options it is a good sign that you should be
//			using the 'infa' instead.  You cannot use the 'infm' to Install into the System Folder either.


resource 'infr' (kEasyInstallFrameworkRsrcID, "easy framework") {
	format0 {
		{	pickFirst,
			{	10400	}
			}
		}
	};

resource 'infr' (kCustomInstallFrameworkRsrcID, "custom framework") {
	format0 {
		{	pickFirst,
			{	10400	}
			}
		}
	};
   
resource 'inrl' (10400, "Add packages and user messages.") {
	format0 {
		{	addPackages {{	9002	}},
			addUserDescription { "Click the Install button to install the Apple Utilities folder.\n" }
			}
		}
	};
 
resource 'inpk' (9002, "The Test Script") {
	format0 {
		showsOnCustom,
		notRemovable,
		dontForceRestart,
		0,			
		0,
		"The Apple Utilities folder",
		{	'infm', 12051	}
		}
	};

resource 'infm' (12051, "The Folder Merge") {
	format0 {
		0,
		10001,
		10000,
		"Apple Utilities Folder"
		}
	};
	
resource 'infs' (10000, "Source File info") {
	'Fldr',
	'Fldr',
	0x0,
	noSearchForFile,
	TypeCrMustMatch,
	"Tidbits:Apple Utilities:"
	};
	
resource 'infs' (10001, "Dest File info") {
	'Fldr',
	'Fldr',
	0x0,
	noSearchForFile,
	TypeCrMustMatch,
	":Apple Utilities:"
	};
