/************************** 


In order to set the Finder flags correctly the logic follows:

Package 68K-clean		-  has only the 68K Macintosh CODE resoures (infa-rsrcFork)  {deletes previous resource fork}
Package 68K-update		-  has only the 68K Macintosh CODE resoures (inrm)  {no flags get set}
Package PPC-clean		-  has the data fork and the cfig & NotPPC resouces  (infa-dataFork & inra for resources)
Package PPC-update		-  has the data fork and the cfig & NotPPC resouce  (infa-dataFork & inrm for resources)
Package Common-clean	-  Has the common resources.  (infa-rsrcFork)  {to set Finder flags}
Package Common-update	-  Has the common resources.  (inrm)  {no flags get set}


For an install where the app doesn't already exist  (need to set the Finder flags in all case via infa)

68K Macintosh version only		(Finder flags get set with the infa common resources)
Package 68K-clean				(inpk; 102)
Package Common					(inpk; 201)

PPC version only				(Finder flags get set with the infa common resources)
Package PPC-clean				(infa; 203)	& (inrm; 303)
Package Common					(infa; 201)

Fat version						(Finder flags get set with the infa common resources)
Package 68K-clean				(inpk; 102)
Package PPC-clean				(infa; 203)	& (inrm; 303)
Package Common					(infa; 201)



For an install where the app already exist  (cannot disturb previous resources- so all resources need to be added via inrm)

68K Macintosh version only		(Other previous resources are not deleted; eg cfrg)
Package 68K-updaten				(inpk; 102)
Package Common					(inpk; 201)

PPC version only				(Other previous resources are not deleted; eg CODE 0)
Package PPC-update				(inpk; 203)	& (inpk; 103)
Package Common					(inpk; 301)

Fat version						(The final CODE 0 will be for the 68K code, instead of the alert for the NotPPC)
Package 68K-update				(inpk; 102)
Package PPC-update				(inpk; 203)	& (inpk; 103)
Package Common					(inpk; 301)




Custom Install Package List:

Place Demo Application for Any Macintosh
	Place Demo Application for 68K Macintosh
	Place Demo Application for PowerPC Macintosh

Update Demo Application for Any Macintosh
	Update Demo Application for 68K Macintosh
	Update Demo Application for PowerPC Macintosh

**********************************/
include "CheckIfInternalUserFunc";

#include "InstallerTypes.r"


#define currentReleaseDate		-1470076096		
#define currentVersion			0x01008000


/************************** Easy Install Rule resources **********************************/
#define kCheckIfInternalDriveUFID	143
#define gestaltSystemType			'sysa'         /* processor type */
#define gestalt68Ksysa				1
#define gestaltPPCsysa				2
#define kUpdatingTargetFile			701
#define kUpdating68Kpart			702
#define kUpdatingPowerPCpart		703

/*
if targetRsrcForkExist then set assertion kUpdatingTargetFile
*/
resource 'infr' (kGlobalFrameworkRsrcID) {
	format0  {{
		pickAll,	{ 701 },
	}};
};

resource 'inrl' (701, "Check If updating target file") {
	format0 {{
		CheckFileRsrcForkExists { 10000 },
		AddAssertion {{ kUpdatingTargetFile }}
	}};
};


/*
if kUpdatingTargetFile & (CODE 2 exist)								{801}
	set assertion kUpdating68Kpart
else if kUpdatingTargetFile & (cfrg 0 exist)						{802}
	set assertion kUpdatingPowerPCpart

if kUpdating68Kpart & kUpdatingPowerPCpart									{811}
	addPackage for update both 68K & PowerPC
else if kUpdating68Kpart & NOT kUpdatingPowerPCpart							{812}
	addPackage for update 68K only
else if NOT kUpdating68Kpart & kUpdatingPowerPCpart							{813}
	addPackage for update PowerPC only
else if kUpdatingTargetFile & targetInternalVolume & gestaltPPCsysa			{814}
	addPackage for update PowerPC only
else if kUpdatingTargetFile & targetInternalVolume							{815}
	addPackage for update 68K only
else
	addPackage for FAT app													{816}
*/
resource 'infr' (kEasyInstallFrameworkRsrcID) {
	format0  {{
		pickAll,	{ 801, 802 },				// update which parts
		pickFirst,	{ 811, 812, 813, 821, 822, 823 },
		}};
	};

resource 'inrl' (801, "Check If updating 68K part") {
	format0 {{
		CheckAllAssertions {{ kUpdatingTargetFile }},
		CheckFileContainsRsrcByID { 10000, 'CODE', 2 },
		AddAssertion {{ kUpdating68Kpart }}
		}};
	};

resource 'inrl' (802, "Check If updating PowerPC Macintosh part") {
	format0 {{
		CheckAllAssertions {{ kUpdatingTargetFile }},
		CheckFileContainsRsrcByID { 10000, 'cfrg', 0 },
		AddAssertion {{ kUpdatingPowerPCpart }}
		}};
	};

resource 'inrl' (811, "Check If updating FAT") {
	format0 {{
		CheckAllAssertions {{ kUpdating68Kpart, kUpdatingPowerPCpart }},
		addUserDescription {"Click Install button to update\n"},
		addUserDescription {"   Demo Application for Any Macintosh\n"},
		addPackages {{30011}}
		}};
	};

resource 'inrl' (812, "Check If updating 68K part only") {
	format0 {{
		CheckAllAssertions {{ kUpdating68Kpart }},
		CheckAllNonAssertions {{ kUpdatingPowerPCpart }},
		addUserDescription {"Click Install button to update\n"},
		addUserDescription {"   Demo Application for 68K Macintosh\n"},
		addPackages {{30012}}
		}};
	};

resource 'inrl' (813, "Check If updating PowerPC Macintosh part only") {
	format0 {{
		CheckAllAssertions {{ kUpdatingPowerPCpart }},
		CheckAllNonAssertions {{ kUpdating68Kpart }},
		addUserDescription {"Click Install button to update\n"},
		addUserDescription {"   Demo Application for PowerPC Macintosh\n"},
		addPackages {{30013}}
		}};
	};

resource 'inrl' (821, "Check If new PowerPC Macintosh Only") {
	format0 {{
		CheckAllNonAssertions {{ kUpdatingTargetFile }},
		checkUserFunction {UserFunctionType, kCheckIfInternalDriveUFID, 0},
		checkGestalt {gestaltSystemType, { gestaltPPCsysa } },
		addUserDescription {"Click Install button to place\n"},
		addUserDescription {"   Demo Application for your PowerPC Macintosh\n"},
		addPackages {{30003}}
		}};
	};

resource 'inrl' (822, "Check If new 68K Only") {
	format0 {{
		checkUserFunction {UserFunctionType, kCheckIfInternalDriveUFID, 0},
		addUserDescription {"Click Install button to place\n"},
		addUserDescription {"   Demo Application for your 68K Macintosh\n"},
		addPackages {{30002}}
		}};
	};

resource 'inrl' (823, "Otherwise handle as Fat App") {
	format0 {{
		addUserDescription {"Click Install button to place\n"},
		addUserDescription {"   Demo Application for Any Macintosh\n"},
		addPackages {{30001}}
		}};
	};


/************************** Custom Install Rule resources **********************************/

/*
if kUpdatingTargetFile					{901}
	addCustomPackage kUpdating
else
	addCustomPackage kNotUpdating		{902}
*/
resource 'infr' (kCustomInstallFrameworkRsrcID) {
	format0  {{
		pickFirst,	{901, 902},
	}};
};

resource 'inrl' (901, "Add Custom Items for update") {
	format0 {{
		CheckAllAssertions {{kUpdatingTargetFile}},
		addCustomItems {{30011}}
		}};
	};

resource 'inrl' (902, "Add Custom Items for scratch copy") {
	format0 {{
		addCustomItems {{30001}}
		}};
	};



/************************** Packages resources **********************************/

/* Package to delete demo app. */
resource 'inpk' (200) {
	format0 {
		doesntShowOnCustom, removable, dontForceRestart,
		0, 0, "Package to delete the demo app",
			{	
			'infa', 200,		//  Delete entire file on removal
			}
		}
	};

/* Sub-Package to copy the common resource fork. */
resource 'inpk' (201) {
	format0 {
		doesntShowOnCustom, notRemovable, dontForceRestart,
		0, 0, "Sub-Package to copy the common resource fork",
			{	
			'infa', 201,		//  Install Common Resource fork
			}
		}
	};

/* Sub-Package to copy PowerPC Macintosh Data Fork. */
resource 'inpk' (203) {
	format0 {
		doesntShowOnCustom, notRemovable, dontForceRestart,
		0, 0, "Sub-Package to copy PowerPC Macintosh Data Fork",
			{	
			'infa', 203,		//  Install PowerPC Macintosh data fork
			}
		}
	};

/* Sub-Package to copy Common Resources. */
resource 'inpk' (301) {
	format0 {
		doesntShowOnCustom, notRemovable, dontForceRestart,
		0, 0, "Sub-Package to copy Common Resources",
			{	
			'inrm', 301,		//  Install Common Resources
			}
		}
	};


/* Package to PLACE Demo App as fat app.*/
resource 'inpk' (30001) {
	format0 {
		showsOnCustom, removable, dontForceRestart,
		30001, 0, "Place Demo Application for Any Macintosh",
			{
			'inpk', 30002,		//  Package 68K part (no update)
			'inpk', 30003,		//  Package PowerPC Macintosh part
			'inpk', 200,		//  Delete entire file on removal
			}
		}
	};

/* Package to UPDATE Demo App as fat app. (update)*/
resource 'inpk' (30011) {
	format0 {
		showsOnCustom, removable, dontForceRestart,
		30001, 0, "Update Demo Application for Any Macintosh",
			{	
			'inpk', 200,		//  Delete entire file on removal
			'inpk', 30012,		//  Package 68K update part
			'inpk', 30013,		//  Package PowerPC Macintosh part
			}
		}
	};

/* Package to PLACE Demo App for 68K only via res-merge. */
resource 'inpk' (30002) {
	format0 {
		showsOnCustom, notRemovable, dontForceRestart,
		30002, 0, "Place Demo Application for 68K Macintosh",
			{	
			'inpk', 201,	// Install Common Resource fork
			'inpk', 102,	// Install 68K Macintosh CODE Resources (inra)
			}
		}
	};

/* Package to UPDATE Demo App for 68K Macintosh only via infa. */
resource 'inpk' (30012) {
	format0 {
		showsOnCustom, notRemovable, dontForceRestart,
		30002, 0, "Update Demo Application for 68K Macintosh",
			{	
			'inpk', 301,	// Install Common Resources
			'inpk', 102,	// Install 68K Macintosh CODE Resources (inra)
			}
		}
	};

/* Package of the 68K CODE resources. */
resource 'inpk' (102) {
	format0 {
		doesntShowOnCustom, notRemovable, dontForceRestart,
		0, 0, "Package for 68K Macintosh CODE resources",
			{	
			'inra', 402,	// Install 68K Macintosh CODE resource 0
			'inra', 412,	// Install 68K Macintosh CODE resource 1
			'inra', 422,	// Install 68K Macintosh CODE resource 2
			'inra', 432,	// Install 68K Macintosh CODE resource 3
			'inra', 442,	// Install 68K Macintosh CODE resource 4
			}
		}
	};

/* Package of native cfrg resource and the NotPPC alert resources. */
resource 'inpk' (103) {
	format0 {
		doesntShowOnCustom, notRemovable, dontForceRestart,
		0, 0, "Package for 68K Macintosh CODE resources",
			{	
			'inra', 403,	// Install PowerPC Macintosh cfrg resource 0
			'inra', 413,	// Install NotPPC CODE resource 0
			'inra', 423,	// Install NotPPC CODE resource 1
			'inra', 433,	// Install NotPPC ALRT resource 27309
			'inra', 443,	// Install NotPPC DITL resource 27309
			'inra', 453,	// Install NotPPC STR  resource 27309
			}
		}
	};

/* Package to PLACE Demo App for PowerPC Macintosh. */
resource 'inpk' (30003) {
	format0 {
		showsOnCustom, notRemovable, dontForceRestart,
		30003, 0, "Place Demo Application for PowerPC Macintosh",
			{	
			'infa', 201,	// Install Common Resources
			'infa', 203,	// Install PowerPC Macintosh Data Fork
			'inrm', 303,	// Install cfrg Resources & NotPPC CODE resources
			}
		}
	};

/* Package to UPDATE Demo App for PowerPC Macintosh. */
resource 'inpk' (30013) {
	format0 {
		showsOnCustom, notRemovable, dontForceRestart,
		30003, 0, "Update Demo Application for PowerPC Macintosh",
			{	
			'inpk', 301,	// Install Common Resources
			'inpk', 203,	// Install PowerPC Macintosh Data Fork
			'inpk', 103,	// Install cfrg Resources & NotPPC CODE resources
			}
		}
	};



resource 'icmt' (30001) {
	currentReleaseDate, currentVersion, 30000,
	"This contains the Demo Application, which can be run on any Macintosh."
	};

resource 'icmt' (30002) {
	currentReleaseDate, currentVersion, 30000,
	"This contains the Demo Application for use on 68K Macintosh."
	};

resource 'icmt' (30003) {
	currentReleaseDate, currentVersion, 30000,
	"This contains the Demo Application for use on PowerPC Macintosh."
	};


data 'ICON' (30000) {
	$"0001 0000 0002 8000 0004 4000 0008 2000"            /* .........@... . */
	$"0010 1000 0020 0800 0040 0400 0080 0200"            /* ..... ...@..... */
	$"0100 0100 0200 0080 0400 0040 0800 0020"            /* ..........@...  */
	$"1000 0010 2000 0008 4000 3F04 8000 4082"            /* .... ...@.?..@ */
	$"4000 8041 2001 3022 1001 C814 080E 7F8F"            /* @.A .0"...... */
	$"0402 3007 0201 0007 0100 8007 0080 6007"            /* ..0.........`. */
	$"0040 1FE7 0020 021F 0010 0407 0008 0800"            /* .@... .......... */
	$"0004 1000 0002 2000 0001 4000 0000 8000"            /* ...... ...@.... */
	};




/************************** Atoms resources **********************************/

/* ResMerge Atom to install common resources. */
resource 'inrm' (301) {
	format0 {
		0,				/* Total size of resources. */
		10000,			/* Target File Spec. */
		20001,			/* Source File Spec. Demo App Parts:Common Part*/
		""
	}
};

/* ResMerge Atom to install 68K code resources. Not really needed......*/
resource 'inrm' (302) {
	format0 {
		0,				/* Total size of resources. */
		10000,			/* Target File Spec. */
		20002,			/* Source File Spec. Demo App Parts:68K Part */
		""
	}
};

/* ResMerge Atom to install common resources. */
resource 'inrm' (303) {
	format0 {
		0,				/* Total size of resources. */
		10000,			/* Target File Spec. */
		20003,			/* Source File Spec. Demo App Parts:PowerPC Macintosh Part*/
		""
	}
};


/* This File Atom deletes the entire file on removes. */
resource 'infa' (200) {
	format1 {
		deleteWhenRemoving,
		dontDeleteWhenInstalling,
		dontCopy,
		dontIgnoreLockedFile,
		dontSetFileLocked,
		useSrcCrDateToCompare,
		srcNeedExist,
		rsrcForkInRsrcFork,
		leaveAloneIfNewer,
		updateExisting,
		copyIfNewOrUpdate,
		rsrcFork,
		dataFork,
		0,
		0,
		10000,
		{	0, 0, 0	},
		0x0,
		0,
		0,
		""
	}
};

/* This File Atom copies the common resources in the resource fork. */
resource 'infa' (201) {
	format1 {
		deleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		dontIgnoreLockedFile,
		dontSetFileLocked,
		useVersProcToCompare,
		srcNeedExist,
		rsrcForkInRsrcFork,
		leaveAloneIfNewer,
		updateExisting,
		copyIfNewOrUpdate,
		rsrcFork,
		noDataFork,
		0,
		0x2000+0x0040,
		10000,
		{	20001, 0, 0	},
		0x0,
		0,
		0,
		""
	}
};

/* This File Atom copies the 68K code contained in the rsrc fork. (for new copy)*/
/*	resource 'infa' (202) {
		format1 {
			dontDeleteWhenRemoving,
			dontDeleteWhenInstalling,
			copy,
			dontIgnoreLockedFile,
			dontSetFileLocked,
			useVersProcToCompare,
			srcNeedExist,
			rsrcForkInRsrcFork,
			leaveAloneIfNewer,
			keepExisting,
			copyIfNewOrUpdate,
			rsrcFork,
			noDataFork,
			0,
			0x2000+0x0040,
			10000,
			{	20002, 0, 0	},
			0x0,
			0,
			0,
			""
		}
	};
*/

/* This File Atom copies the RISC code contained in the data fork. */
resource 'infa' (203) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		dontIgnoreLockedFile,
		dontSetFileLocked,
		useVersProcToCompare,
		srcNeedExist,
		rsrcForkInRsrcFork,
		leaveAloneIfNewer,
		updateExisting,
		copyIfNewOrUpdate,
		noRsrcFork,
		dataFork,
		0,
		0x2000+0x0040,
		10000,
		{	20003, 0, 0	},
		0x0,
		0,
		0,
		""
	}
};



resource 'inra' (402) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		updateEvenIfNewer,
		noTgtRequired,
		updateExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		0,
		0x0,
		"",
		{	20002, 'CODE', 0, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (412) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		updateEvenIfNewer,
		noTgtRequired,
		updateExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		1,
		0x0,
		"",
		{	20002, 'CODE', 1, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (422) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		updateEvenIfNewer,
		noTgtRequired,
		updateExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		2,
		0x0,
		"",
		{	20002, 'CODE', 2, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (432) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		updateEvenIfNewer,
		noTgtRequired,
		updateExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		3,
		0x0,
		"",
		{	20002, 'CODE', 3, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (442) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		updateEvenIfNewer,
		noTgtRequired,
		updateExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		4,
		0x0,
		"",
		{	20002, 'CODE', 4, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};


resource 'inra' (403) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		leaveAloneIfNewer,
		noTgtRequired,
		updateExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'cfrg',
		0,
		0x0,
		"",
		{	20003, 'cfrg', 0, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (413) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		leaveAloneIfNewer,
		noTgtRequired,
		keepExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		0,
		0x0,
		"",
		{	20003, 'CODE', 0, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (423) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		leaveAloneIfNewer,
		noTgtRequired,
		keepExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'CODE',
		1,
		0x0,
		"",
		{	20003, 'CODE', 1, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (433) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		leaveAloneIfNewer,
		noTgtRequired,
		keepExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'ALRT',
		27309,
		0x0,
		"",
		{	20003, 'ALRT', 27309, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (443) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		leaveAloneIfNewer,
		noTgtRequired,
		keepExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'DITL',
		27309,
		0x0,
		"",
		{	20003, 'DITL', 27309, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};

resource 'inra' (453) {
	format1 {
		dontDeleteWhenRemoving,
		dontDeleteWhenInstalling,
		copy,
		leaveAloneIfNewer,
		noTgtRequired,
		keepExisting,
		copyIfNewOrUpdate,
		ignoreProtection,
		srcNeedExist,
		byID,
		nameNeedNotMatch,
		0,
		10000,
		'STR ',
		27309,
		0x0,
		"",
		{	20003, 'STR ', 27309, 0, ""	},
		0x0,
		0,
		0,
		""
		}
	};



/************************** Target File Spec. resources **********************************/
resource 'intf' (10000) {
	format0 {
		noSearchForFile, TypeCrNeedNotMatch, 'APPL', 'WATR', 0,
		"folder-user:WaterTank Demo App"
		}
	};


/************************** Source File Spec. resources **********************************/
resource 'infs' (20001) {
	'rsrc', 'RSED', 0x1, noSearchForFile, TypeCrMustMatch,
	"WaterTank Parts:Common Part"
	};

resource 'infs' (20002) {
	'rsrc', 'RSED', 0x1, noSearchForFile, TypeCrMustMatch,
	"WaterTank Parts:68K Macintosh Part"
	};

resource 'infs' (20003) {
	'rsrc', 'RSED', 0x1, noSearchForFile, TypeCrMustMatch,
	"WaterTank Parts:PowerPC Macintosh Part"
	};


// The preferenece resource allows that script writer to specify certain attributes of the Installer's
// interface and actions.  This resource is the default if the script writer does not provide one.
resource 'inpr' (300) {
	format0 {
		useFolderTargetMode,
		allowUserToSetSystemDisk,
		showSelectedSizeInCustom,
		noSetupFunctionSupplied,
		dontAllowCleanInstall,
		dontAllowServerAsTarget,
		0,
		0,
			{	
			301, 311, 301, 311,
			302, 312, 302, 312
			},
		"Demo Application Folder"
		}
	};



